Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package ast
  Definition Classes
    nsc
-  package parser
  Definition Classes
    ast
-  trait Scanners extends ScannersCommon
  Definition Classes
    parser
- CommonTokenData
- DocScanner
- MalformedInput
- ParensAnalyzer
- Scanner
- ScannerCommon
- ScannerData
- SourceFileScanner
- TokenData
- UnitScanner

c

scala.tools.nsc.ast.parser.Scanners

# ParensAnalyzer

###

#### class ParensAnalyzer extends UnitScanner

Source
  Scanners.scala

Linear Supertypes
UnitScanner, SourceFileScanner, Scanner, Scanners.DocScanner, Scanners.ScannerCommon, ScannerData, TokenData, Scanners.CommonTokenData, CharArrayReader, CharArrayReaderData, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ParensAnalyzer
2. UnitScanner
3. SourceFileScanner
4. Scanner
5. DocScanner
6. ScannerCommon
7. ScannerData
8. TokenData
9. CommonTokenData
10. CharArrayReader
11. CharArrayReaderData
12. AnyRef
13. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new ParensAnalyzer(unit: Global.CompilationUnit, patches: List[BracePatch])

### Type Members

1.  class CharArrayLookaheadReader extends CharArrayReader
   Definition Classes
     CharArrayReader

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from ParensAnalyzer toany2stringadd[ParensAnalyzer] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (ParensAnalyzer, B)
   Implicit
     This member is added by an implicit conversion from ParensAnalyzer toArrowAssoc[ParensAnalyzer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def adjustSepRegions(lastToken: Scanners.Token): Unit
   Definition Classes
     Scanner
7.  def applyBracePatch(): Boolean

   Insert or delete a brace, if a patch exists for this offset

   Insert or delete a brace, if a patch exists for this offset

   Definition Classes
     UnitScanner → Scanner
8.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
9.  val balance: Map[Int, Int]
10.  val base: Int

    the base of a number

    the base of a number

    Definition Classes
      TokenData
11.  def beginDocComment(prefix: String): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
12.  val bracePairs: List[BracePair]

    The list of matching top-level brace pairs (each of which may contain nested brace pairs).

13.  val buf: Array[Char]
    Definition Classes
      SourceFileScanner → CharArrayReader
14.  val cbuf: java.lang.StringBuilder

    A character buffer for literals

    A character buffer for literals

    Definition Classes
      Scanner
15.  val ch: Char

    the last read character

    the last read character

    Definition Classes
      CharArrayReaderData
16.  def charLitOr(op: () => Unit): Unit

    Parse character literal if current character is followed by \', or follow with given op and return a symbol literal token

    Parse character literal if current character is followed by \', or follow with given op and return a symbol literal token

    Definition Classes
      Scanner
17.  val charOffset: Int

    The offset one past the last read character

    The offset one past the last read character

    Definition Classes
      CharArrayReaderData
18.  def charVal: Char

    Convert current strVal to char value.

    Convert current strVal to char value.

    Definition Classes
      Scanner
19.  def checkNoLetter(): Unit
    Definition Classes
      Scanner
    Annotations
      @inline()
20.  def checkNoTrailingSeparator(): Unit
    Definition Classes
      Scanner
21.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
22.  def column(offset: Scanners.Offset): Int
23.  def copyFrom(sd: ScannerData): ParensAnalyzer.this.type
    Definition Classes
      ScannerData
24.  def copyFrom(td: TokenData): ParensAnalyzer.this.type
    Definition Classes
      TokenData
25.  def copyFrom(cd: CharArrayReaderData): ParensAnalyzer.this.type
    Definition Classes
      CharArrayReaderData
26.  def deleteRBrace(): List[BracePatch]
27.  def deprecationWarning(off: Scanners.Offset, msg: String, since: String): Unit
    Definition Classes
      UnitScanner → SourceFileScanner → ScannerCommon
28.  def deprecationWarning(msg: String, since: String): Unit
    Definition Classes
      Scanner
29.  def discardDocBuffer(): Unit

    To prevent doc comments attached to expressions from leaking out of scope onto the next documentable entity, they are discarded upon passing a right brace, bracket, or parenthesis.

    To prevent doc comments attached to expressions from leaking out of scope onto the next documentable entity, they are discarded upon passing a right brace, bracket, or parenthesis.

    Definition Classes
      DocScanner
30.  def doubleVal: Double
    Definition Classes
      Scanner
    Annotations
      @inline()
31.  def doubleVal(negated: Boolean): Double

    Convert current strVal, base to double value.

    Convert current strVal, base to double value.

    Definition Classes
      Scanner
32.  def emitIdentifierDeprecationWarnings: Boolean

    Determines whether this scanner should emit identifier deprecation warnings, e.g.

    Determines whether this scanner should emit identifier deprecation warnings, e.g. when seeing `macro` or `then`, which are planned to become keywords in future versions of Scala.

    Definition Classes
      ParensAnalyzer → Scanner
33.  def ensuring(cond: (ParensAnalyzer) => Boolean, msg: => Any): ParensAnalyzer
    Implicit
      This member is added by an implicit conversion from ParensAnalyzer toEnsuring[ParensAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
34.  def ensuring(cond: (ParensAnalyzer) => Boolean): ParensAnalyzer
    Implicit
      This member is added by an implicit conversion from ParensAnalyzer toEnsuring[ParensAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
35.  def ensuring(cond: Boolean, msg: => Any): ParensAnalyzer
    Implicit
      This member is added by an implicit conversion from ParensAnalyzer toEnsuring[ParensAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
36.  def ensuring(cond: Boolean): ParensAnalyzer
    Implicit
      This member is added by an implicit conversion from ParensAnalyzer toEnsuring[ParensAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
37.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
38.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
39.  def error(offset: Scanners.Offset, msg: String): Unit
    Definition Classes
      ParensAnalyzer → UnitScanner → SourceFileScanner → ScannerCommon
40.  final def fetchToken(): Unit

    read next token, filling TokenData fields of Scanner.

    read next token, filling TokenData fields of Scanner.

    Attributes
      protected
    Definition Classes
      Scanner
    Annotations
      @tailrec()
41.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
42.  def finishDocComment(): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
43.  def floatVal: Float
    Definition Classes
      Scanner
    Annotations
      @inline()
44.  def floatVal(negated: Boolean): Float

    Convert current strVal, base to float value.

    Convert current strVal, base to float value.

    Definition Classes
      Scanner
45.  def flushDoc(): Global.DocComment
    Definition Classes
      DocScanner
46.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from ParensAnalyzer toStringFormat[ParensAnalyzer] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
47.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
48.  def getFraction(): Unit

    read fractional part and exponent of floating point number if one is present.

    read fractional part and exponent of floating point number if one is present.

    Attributes
      protected
    Definition Classes
      Scanner
49.  def getLitChar(): Unit

    copy current character into cbuf, interpreting any escape sequences, and advance to next character.

    copy current character into cbuf, interpreting any escape sequences, and advance to next character.

    Attributes
      protected
    Definition Classes
      Scanner
50.  def getNumber(): Unit

    Read a number into strVal.

    Read a number into strVal.

    The `base` can be 2, 10 or 16.

    Attributes
      protected
    Definition Classes
      Scanner
51.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
52.  def healBraces(): List[BracePatch]

    overridden in UnitScanners

    overridden in UnitScanners

    Definition Classes
      UnitScanner → Scanner
53.  def inFirstOfStat(token: Scanners.Token): Boolean

    Can token start a statement?

    Can token start a statement?

    Definition Classes
      Scanner
54.  def inLastOfStat(token: Scanners.Token): Boolean

    Can token end a statement?

    Can token end a statement?

    Definition Classes
      Scanner
55.  def incompleteInputError(off: Scanners.Offset, msg: String): Unit
    Definition Classes
      UnitScanner → SourceFileScanner → ScannerCommon
56.  def incompleteInputError(msg: String): Unit

    signal an error where the input ended in the middle of a token

    signal an error where the input ended in the middle of a token

    Definition Classes
      Scanner
57.  def init(): Unit

    Initialization method: read first char, then first token

    Initialization method: read first char, then first token

    Definition Classes
      Scanner
58.  def insertPatch(patches: List[BracePatch], patch: BracePatch): List[BracePatch]
59.  def insertRBrace(): List[BracePatch]
60.  def intVal: Long
    Definition Classes
      Scanner
    Annotations
      @inline()
61.  def intVal(negated: Boolean): Long

    Convert current strVal, base to long value.

    Convert current strVal, base to long value. This is tricky because of max negative value.

    Conversions in base 2, 10 and 16 are supported. Number separators are skipped on the fly.

    Definition Classes
      Scanner
62.  def invalidEscape(): Unit
    Attributes
      protected
    Definition Classes
      Scanner
63.  def invalidUnicodeEscape(n: Int): Unit
    Attributes
      protected
    Definition Classes
      Scanner
64.  def isAtEnd: Boolean
    Definition Classes
      Scanner
65.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
66.  def isTrailingComma(right: Scanners.Token): Boolean
    Definition Classes
      Scanner
67.  val lastLineStartOffset: Int

    The start offset of the line before the current one

    The start offset of the line before the current one

    Definition Classes
      CharArrayReaderData
68.  val lastOffset: Scanners.Offset

    the offset of the character following the token preceding this one

    the offset of the character following the token preceding this one

    Definition Classes
      TokenData
69.  def line(offset: Scanners.Offset): Int
70.  val lineStart: ArrayBuffer[Int]

    The offset of the first token on this line, or next following line if blank

71.  val lineStartOffset: Int

    The start offset of the current line

    The start offset of the current line

    Definition Classes
      CharArrayReaderData
72.  def lookaheadReader: CharArrayLookaheadReader

    A new reader that takes off at the current character position

    A new reader that takes off at the current character position

    Definition Classes
      CharArrayReader
73.  def lookingAhead[A](body: => A): A
    Definition Classes
      Scanner
74.  val name: Global.TermName

    the name of an identifier

    the name of an identifier

    Definition Classes
      TokenData → CommonTokenData
75.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
76.  val next: TokenData

    we need one token lookahead and one token history

    we need one token lookahead and one token history

    Definition Classes
      ScannerData
77.  final def nextChar(): Unit

    Advance one character; reducing CR;LF pairs to just LF

    Advance one character; reducing CR;LF pairs to just LF

    Definition Classes
      CharArrayReader
78.  final def nextRawChar(): Unit

    Advance one character, leaving CR;LF pairs intact.

    Advance one character, leaving CR;LF pairs intact. This is for use in multi-line strings, so there are no "potential line ends" here.

    Definition Classes
      CharArrayReader
79.  def nextToken(): Unit

    Produce next token, filling TokenData fields of Scanner.

    Produce next token, filling TokenData fields of Scanner.

    Definition Classes
      Scanner → ScannerCommon
80.  def nextTokenAllow(name: Global.Name): Unit

    Get next token, and allow the otherwise deprecated ident `name`

    Get next token, and allow the otherwise deprecated ident `name`

    Definition Classes
      Scanner
81.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
82.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
83.  val offset: Scanners.Offset

    the offset of the first character of the current token

    the offset of the first character of the current token

    Definition Classes
      TokenData
84.  def parenBalance(token: Scanners.Token): Int

    overridden in UnitScanners

    overridden in UnitScanners

    Definition Classes
      UnitScanner → Scanner
85.  lazy val parensAnalyzer: ParensAnalyzer
    Definition Classes
      UnitScanner
86.  def postProcessToken(): Unit
    Definition Classes
      Scanner
87.  val prev: TokenData
    Definition Classes
      ScannerData
88.  def processCommentChar(): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
89.  def putChar(c: Char): Unit

    append Unicode character to "cbuf" buffer

    append Unicode character to "cbuf" buffer

    Attributes
      protected
    Definition Classes
      Scanner
90.  final def putCommentChar(): Unit
    Attributes
      protected
    Definition Classes
      Scanner
91.  def registerDocComment(raw: String, pos: Global.Position): Unit
    Definition Classes
      DocScanner
92.  def resume(lastCode: Scanners.Token): Unit
    Definition Classes
      Scanner
93.  var sepRegions: List[Scanners.Token]

    a stack of tokens which indicates whether line-ends can be statement separators also used for keeping track of nesting levels.

    a stack of tokens which indicates whether line-ends can be statement separators also used for keeping track of nesting levels. We keep track of the closing symbol of a region. This can be RPAREN if region starts with '(' RBRACKET if region starts with '[' RBRACE if region starts with '{' ARROW if region starts with 'case' STRINGLIT if region is a string interpolation expression starting with '${' (the STRINGLIT appears twice in succession on the stack iff the expression is a multiline string literal).

    Definition Classes
      Scanner
94.  final def skipComment(): Boolean

    Returns true if a comment was skipped.

    Returns true if a comment was skipped.

    Definition Classes
      Scanner
    Note

      Pre-condition: ch == '/'

95.  final def skipNestedComments(): Unit
    Definition Classes
      Scanner
    Annotations
      @tailrec()
96.  def skipToken(): Scanners.Offset

    read next token and return last offset

    read next token and return last offset

    Definition Classes
      Scanner
97.  def skipTrailingComma(right: Scanners.Token): Boolean
    Definition Classes
      Scanner → ScannerCommon
98.  val source: SourceFile
    Definition Classes
      SourceFileScanner
99.  val strVal: String

    the string value of a literal

    the string value of a literal

    Definition Classes
      TokenData
100.  final def synchronized[T0](arg0: => T0): T0
     Definition Classes
       AnyRef
101.  def syntaxError(msg: String): Unit

     generate an error at the current token offset

     generate an error at the current token offset

     Definition Classes
       Scanner
102.  def syntaxError(off: Scanners.Offset, msg: String): Unit

     generate an error at the given offset

     generate an error at the given offset

     Definition Classes
       Scanner
103.  var tabSeen: Boolean
104.  def toString(): String
     Definition Classes
       Scanner → AnyRef → Any
105.  val token: Scanners.Token

     the next token

     the next token

     Definition Classes
       TokenData → CommonTokenData
106.  val unit: Global.CompilationUnit
     Definition Classes
       UnitScanner
107.  final def wait(): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException])
108.  final def wait(arg0: Long, arg1: Int): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException])
109.  final def wait(arg0: Long): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws(classOf[java.lang.InterruptedException]) @native()
110.  def warning(off: Scanners.Offset, msg: String, category: WarningCategory): Unit
     Definition Classes
       UnitScanner → SourceFileScanner → ScannerCommon

### Deprecated Value Members

1.  def →[B](y: B): (ParensAnalyzer, B)
   Implicit
     This member is added by an implicit conversion from ParensAnalyzer toArrowAssoc[ParensAnalyzer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from UnitScanner

### Inherited from SourceFileScanner

### Inherited from Scanner

### Inherited from Scanners.DocScanner

### Inherited from Scanners.ScannerCommon

### Inherited from ScannerData

### Inherited from TokenData

### Inherited from Scanners.CommonTokenData

### Inherited from CharArrayReader

### Inherited from CharArrayReaderData

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromParensAnalyzer to any2stringadd[ParensAnalyzer]

### Inherited by implicit conversion StringFormat fromParensAnalyzer to StringFormat[ParensAnalyzer]

### Inherited by implicit conversion Ensuring fromParensAnalyzer to Ensuring[ParensAnalyzer]

### Inherited by implicit conversion ArrowAssoc fromParensAnalyzer to ArrowAssoc[ParensAnalyzer]

### Ungrouped